Packages - Freedom Issue #1426

[anki] depend on qt5-webengine
2017-07-29 04:57 PM - Elon_Satoshi

Status: in progress % Done: 0%
Priority: freedom issue

Assignee: bill-auger

Category:

Description

$ sudo pacman -S anki
resolving dependencies...
warning: cannot resolve "gt5-webengine", a dependency of "anki"
The following package cannot be upgraded due to unresolvable dependencies:
anki
<pre>

I am currently installing it with --assume-installed gt5-webengine to see if it runs. If not, mayb
e we could compile it to run without gt5-webengine, and then remove the dependency.

Related issues:

Related to Packages - Freedom Issue #1167: [chromium][electron][gt5-webengine... confirmed
Related to Packages - Packaging Request #1830: Let's revert Anki to version 2... fixed
History

#1 - 2017-07-29 06:27 PM - Elon_Satoshi

Anki won't run without the qt5-webengine dependency

Traceback (most recent call last):
File "/usr/bin/anki", line 6, in <module>
import agt
File "/usr/share/anki/aqgt/__init___.py", line 14, in <module>
from agt.gt import *
File "/usr/share/anki/aqgt/gt.py", line 17, in <module>
from PyQt5.QtWebEngineWidgets import QWebEnginePage
ModuleNotFoundError: No module named 'PyQt5.QtWebEngineWidgets'

I think it needs to be rebranded for Parabola. Maybe somebody could show me how to remove qgt5-webengine from a python project.

#2 - 2017-08-03 05:06 PM - Elon_Satoshi

Would it be possible to use gtwebkit instead of gtwebengine in Anki? How would | do that?

#3 - 2017-08-17 10:55 PM - isacdaavid

- Related to Freedom Issue #1167: [chromium][electron][qt5-webengine][qt6-webengine] QTWebgine/Electron embeds "entire Chromium platform"
added

#4 - 2017-08-17 11:17 PM - isacdaavid
- Assignee set to isacdaavid

- Subject changed from [anki] depends on qt5-webengine to [anki][kalgebra][libkgapi][telepathy-kde-text-ui] depends on qt5-webengine

anki is just one of a handful of new packages that fail to install (let alone run) because of their dependency on qt5-webengine. since the blacklist has
been called into question for its inclusion of gt5-webengine, | would rather go to the root of the problem (#1167) and find out whether | can solve it all
there, before attempting to change affected packages like anki. so stay tuned.

#5 - 2017-08-26 06:22 PM - isacdaavid
- Priority changed from bug to freedom issue

- Subject changed from [anki][kalgebra][libkgapi][telepathy-kde-text-ui] depends on qt5-webengine to
[anki][kalgebra][libkgapi][telepathy-kde-text-ui][luminancehdr][pgadmin4][psi-plus-plugins] depend on qt5-webengine

#6 - 2019-02-22 08:43 PM - bill-auger
https://labs.parabola.nu/issues/1290
https://labs.parabola.nu/issues/1167

- Subject changed from [anki][kalgebra][libkgapi][telepathy-kde-text-uil[luminancehdr][pgadmin4][psi-plus-plugins] depend on qt5-webengine to [anki]
depend on qt5-webengine

#7 - 2019-11-02 06:16 PM - bill-auger
- Related to Packaging Request #1830: Let's revert Anki to version 2.0.* added

#8 - 2020-02-14 07:42 AM - theova

Here is the discussion in Ankis Support page: [1]
There are already forks of anki without gt-webengine.

The more promising fork seems CCBC [2]. The problem is that it needs
gt4, which is no longer in the repositories... So | am not able to run it [3].

Meanwhile, Parabola has some alternatives [4].

[1]: hitps://anki.tenderapp.com/discussions/ankidesktop/37764-webkit
[2]: https://github.com/lovac42/CCBC

[3]: https://github.com/lovac42/CCBC/issues/14

[4]: hitps://wiki.parabola.nu/List_of Applications/Other#Flashcards

#9 - 2020-05-14 02:34 AM - nona
For completeness, | am adding this: https:/labs.parabola.nu/boards/18/topics/267 ?r=439

#10 - 2020-07-08 08:10 PM - Anonymous

Just discovered this issue about Anki while moving to Parabola. It's a shame because Anki is a great piece of software. My post is not very useful but
| just wanted to add another voice to show that Anki is quite used out there.

I don’t know anything about Qt, just some Ruby (which could help to understand Python) so I'm not sure to be able to help. If there’s anything | can do
to make Anki come back to Parabola, I'd be glad to do it.

Thanks for your work.

#11 - 2020-07-09 05:47 AM - bill-auger

the ccbc fork is probably the best way forward on this - the PKGBIULD that nona made seems to be working as expected - the licensing needs more
checking

#12 - 2020-07-09 08:09 AM - bill-auger

if ccbc does not work out, eli suggested that mnemosyne is a
suitable replacement - its data files are not compatible with
anki; but mnemosyne can import anki data files - though it
currently uses webengine also, the upstream may be more
receptive to patches to change that

#13 - 2020-07-10 02:05 AM - nona
bill-auger wrote:

eli suggested

who's eli?
bill-auger wrote:

that mnemosyne is a suitable replacement

I'll try to get in touch.

#14 - 2020-07-10 02:14 AM - bill-auger

- Assignee changed from isacdaavid to bill-auger

- Tracker changed from Bug to Freedom Issue

eliis 'eschwartz', one of the community moderators of the forum and bug tracker

i mentioned mnemosyne, for in case that ccbc does not work out - i have packaged it, and it seems to work perfectly - i was going to publish it to
pcr-testing now, so that others who are more familiar with it can try it out

2022-09-30 2/9


https://anki.tenderapp.com/discussions/ankidesktop/37764-webkit
https://github.com/lovac42/CCBC
https://github.com/lovac42/CCBC/issues/14
my main concern with ccbc is the massive amount of treatment the PKGBUILD applies - depending on how often new versions are released, it may
need reworking for each release - - so it could be troublesome to maintain, especially if the upstream maintainer is not responsive - if you want to
maintain the package, thats great, you would need to give a contact email address though

were all of those changes necessary in order to support arch (without QT4)? - maybe these could be offered upstream, at least to establish a rapport -
QT4 is not an easy path into the future

#15 - 2020-07-10 04:23 AM - bill-auger
ok the package is in the pcr-testing repos now, if people want to test it - it is named 'anki-ccbc'
note to self (if we keep it):

e move this to libre
e add it as the anki replacement in the blacklist

#16 - 2020-07-10 04:23 AM - bill-auger

- Status changed from open to in progress

#17 - 2020-07-11 12:09 AM - nona

bill-auger wrote:
my main concern with ccbc is the massive amount of treatment the PKGBUILD applies - depending on how often new versions are released, it
may need reworking for each release - - so it could be troublesome to maintain, especially if the upstream maintainer is not responsive

Yes, | know :S, but since this is a no-strings-attached system, | can just elegantly decline to continue at some point. May be, someone else will pick it

up by then.
were all of those changes necessary in order to support arch (without QT4)? - maybe these could be offered upstream, at least to establish a
rapport

Every change that | made was necessary at some point. The more | used CCBC, the more | had to tweak it. Right now, | can still find some bugs, but

most of them are to transition from Qt4 to Qt5.

| already tried to send my modifications by mail to both pyqt4topyqt5 and lovac42, but | do not have nor want a github account (call it idiosyncrasy, if
you want--1 just don't want anything to do with M$).

i mentioned mnemosyne, for in case that ccbc does not work out
Regarding mnemosyne, it's hosted on github as well, and their mailing list is based on gﬂﬂgle (another idiosyncrasy of mine). They seem to have a
full team of people working on the project, and they even have a suggestions section. | just sent one to start using QtWebkKit instead of QtWebEngine.
| sincerely do not think that they are going to listen to it, and | would be very glad to be proven wrong. | could also see that the project has some other
programming languages (research students?) like Java, which indicates to me that the base code must be a big spaghetti (note that this comment is

completely uninformed, and | may take some fire for that. | really do not mean to insult them, it's just to express my own unwillingness to explore it).

- if you want to maintain the package, thats great, you would need to give a contact email address though

As | said, | will look into the packaging documentation (this week or the next, and | will let you know).

Thanks!

#18 - 2020-07-12 04:47 AM - eschwartz

To be clear, | don't expect you to be particularly successful getting most people to care about one browser engine over another.

But browser engines in general seem to be ludicrous overkill for what most people use them for, and it's incredibly wasteful. Instead, my suggestion
was that such programs should be ported over to use QTextBrowser, which supports HTML 4 for rich text but isn't actually a browser, doesn't require
as much resources as a browser, can be done with just the QtWidgets module and thus has a much lighter installation footprint (resulting in smaller

installers for Windows/macOS in addition to fewer package dependencies on Linux), etc.

This is good advice for any program, but Anki is aggressively uninterested in the opinions of people exercising their Free Software right to build the
source code themselves. Mnemosyne seems a lot more open to ideas...

#19 - 2020-07-12 06:53 AM - bill-auger

just yesterday, i watched a talk of kevlin henney mocking that practice as "grabbing for a banana and pulling in a gorilla with it"

#20 - 2020-07-15 08:02 PM - theova
bill-auger wrote:

ok the package is in the pcr-testing repos now, if people want to test it - it is named 'anki-ccbc'

| experienced the following:

e Missing file during nstallation:

sudo pacman -U tmp/anki-ccbc-0.1.0-1-any.pkg.tar.xz

Processing package changes...
xdg-mime: file '/usr/share/mime/packages/anki.xml' does not exist
error: command failed to execute correctly

If | click "Add" (left to "Decks") | get

An error occurred. Please use Tools > Check Database to see if that fixes the problem.
If problems persist, you are SOL.

Anki 2.1.16_ccbc (dev) Python 3.8.3 Ot 5.15.0 PyQt 5.15.0

Platform: Linux

Flags: frz=False ao=False sv=1

Caught exception:
Traceback (most recent call last):
File "/usr/share/anki-ccbc/aqt/webview.py", line 212, in _linkHandler
self.linkHandler (url.toString())
File "/usr/share/anki-ccbc/aqt/toolbar.py", line 73, in _linkHandler
self.link_handlers[link] ()
File "/usr/share/anki-ccbc/agt/toolbar.py", line 87, in _addLinkHandler
self.mw.onAddCard()
File "/usr/share/anki-ccbc/agt/main.py", line 781, in onAddCard

instance = agt.dialogs.open (name, self)
File "/usr/share/anki-ccbc/aqt/__init___.py", line 72, in open
instance = creator (*args)

File "/usr/share/anki-ccbc/aqt/addcards.py", line 38, in __init___
self.setupChoosers ()

File "/usr/share/anki-ccbc/aqgt/addcards.py", line 60, in setupChoosers
self.modelChooser = agt.modelchooser.ModelChooser (
File "/usr/share/anki-ccbc/agt/modelchooser.py", line 23, in __init___

self.setMargin (0)
AttributeError: 'ModelChooser' object has no attribute 'setMargin'

| am not able to add any cards and the program is not usable at all for me...

#21 - 2020-07-16 02:24 AM - nona

| am busy at the moment, trying to get my linux kernel to work with my graphics card. This may take a little longer than | expected. Sorry.

#22 - 2020-07-16 02:40 AM - bill-auger

again, i could not test this fully because i do not have any
"cards"; and i can not assume anything about their format -

if those cards are made of python, maybe some of them need
the same qt4->qt5 treatment - if they are just data, then

that python bug is probably easily fixed

could someone attach a set of cards or direct me to where i
could find a variety of them?

#23 - 2020-07-16 02:50 AM - bill-auger

- Description updated

#24 - 2020-07-16 03:13 AM - nona

| am not able to add any cards and the program is not usable at all for me...
| frankly never create cards, | just use what is available. The way | have been working about this is that when | get an error, | look into the
documentation of Qt5 and Qt4 to see what are the equivalencies or what needs to be changed.

In the case of the mentioned error, the function is obsolete, so the solution would be to "Use setContentsMargins() and getContentsMargins()
instead.", as suggested by the documentation.

Therefore, looking for =.setMargin= in the source code,

find . -name '*.py' -type f -exec grep --color -nH --null -e '\.setMargin(0)' \{\} +
| found:

./agt/modelchooser.py:023: self.setMargin (0)

./aqgt/deckchooser.py:023: self.setMargin (0)

(line 23 must be a hell of a coincidence or an initial kill-yank)
Thus, | modified the following line in my PKGBUILD:

's$QDesktopServices. \ (Documents\ |Home\) \ (Location\) %$QStandardPaths.\1\2%g; "'

so that it has one more line after that:

's%QDesktopServices. \ (Documents\ |Home\) \ (Location\)%$QStandardPaths.\1\2%g; "'

's%self.setMargin(0) $self.setContentsMargins (0) %;
That line basically replaces =self.setMargin= with =self.setContentsMargins=

which now creates a new error:

Caught exception:
Traceback (most recent call last):
File "/usr/share/anki/aqt/webview.py", line 214, in _linkHandler
self.linkHandler (url.toString())
File "/usr/share/anki/aqgt/toolbar.py", line 74, in _linkHandler
self.link_handlers[link] ()
File "/usr/share/anki/agt/toolbar.py", line 88, in _addLinkHandler
self.mw.onAddCard ()
File "/usr/share/anki/agt/main.py", line 789, in onAddCard
instance = agt.dialogs.open (name, self)
File "/usr/share/anki/aqt/__init__.py", line 72, in open
instance = creator (*args)
File "/usr/share/anki/aqgt/addcards.py", line 38, in __init___
self.setupChoosers ()
File "/usr/share/anki/aqgt/addcards.py", line 65, in setupChoosers
self.modelChooser = aqgt.modelchooser.ModelChooser (
File "/usr/share/anki/aqgt/modelchooser.py", line 23, in __init_
self.setContentsMargins (0)
TypeError: arguments did not match any overloaded call:
setContentsMargins (self, int, int, int, int): not enough arguments
setContentsMargins (self, QMargins): argument 1 has unexpected type 'int'

This error happens, evidently due to the type of data provided to the function and it was an overlook on my side, but | don't have much time now, and
needs to be fixed in a similar way. It is that simple, but time-consuming, to fix the whole thing. | don't even know what the 'Add' button is supposed to
do, and | guess that it is meant to create a deck or a card. If it is supposed to get a deck from an =.apkg= file, just use 'File' > 'Import'. However, | can

hardly believe that the developers would have both options in such a repetitive way.

If nobody fixes that bug, | will do it as soon as possible. | don't know what is more useful: to read the packaging documentation and prepare for it, or

to actually fix the bug. | already pushed the change that | made to my repo

#25 - 2020-07-16 03:17 AM - nona

bill-auger wrote:
again, i could not test this fully because i do not have any
"cards"; and i can not assume anything about their format -
if those cards are made of python, maybe some of them need

the same qt4->qt5 treatment - if they are just data, then
that python bug is probably easily fixed

could someone attach a set of cards or direct me to where i
https://doc.qt.io/qt-5/qstandardpaths.html
https://doc.qt.io/archives/qt-4.8/qdesktopservices.html
https://doc.qt.io/qt-5/qlayout-obsolete.html
https://www.notabug.org/broncodev/ccbc-pkgbuild

could find a variety of them?

Sure, you can find many on the AnkiWeb (which | really think is great). The ones | have are really too big to share here.

#26 - 2020-07-16 04:46 AM - bill-auger

theova wrote:

xdg-mime: file '/usr/share/mime/packages/anki.xml' does not exist

that is fixed in abslibre/pcr-testing:

https://git.parabola.nu/abslibre.git/tree/pcr-testing/anki-ccbc?id=d8d414c66f4dd069a31eb1aal34443a7{b59215¢7

#27 - 2020-07-16 04:58 AM - bill-auger

for the sake of considering more alternatives, is there any reason why 'parley' is not a suitable replacement for 'anki' ? - 'parley' is already in [libre],
patched to use 'gt5-webkit'

"Program to help you memorize things. It uses the spaced repetition learning method, also known as flash cards
"

maybe parley is not general-purpose though - the package description is:
"Vocabulary Trainer, without gt5-webengine"

#28 - 2020-07-16 07:40 AM - Anonymous

- File collection.apkg added

bill-auger wrote:

for the sake of considering more alternatives, is there any reason why 'parley' is not a suitable replacement for 'anki' ? - 'parley' is already in
[libre], patched to use 'qt5-webkit'

"Program to help you memorize things. It uses the spaced repetition learning method, also known as flash cards"

maybe parley is not general-purpose though - the package description is:

"Vocabulary Trainer, without gt5-webengine”
| haven't tested parley yet. The main hurdle is that it is a KDE software. Of course, if one’s running KDE, no problem. But, for other people trying to
be GNOME or KDE-free on a minimal system, this is an inconvenience. | run XFCE and | checked on Pacman the parley installation: for this tiny little
program, | need to install 214MB of KDE dependencies...
Anki and other Anki-based software have the advantage of being DE-independent.
As for Anki decks, | join my English and Japanese collection | made myself so you can test. It's minimal in the way that it's just plain text, there is no
media attached to the cards so it's quite light. It might not represent the performance you would get with a more bloated set of cards.

Also, it comes from Anki 2.0, so from what | understood, the version that still had the gt-webkit. Though, it shouldn’t have any consequences on the
deck itself.

#29 - 2020-07-16 02:23 PM - eschwartz

theova wrote:
bill-auger wrote:

ok the package is in the pcr-testing repos now, if people want to test it - it is named 'anki-ccbc'

| experienced the following:

e Missing file during nstallation:

xdg-mime: file '/usr/share/mime/packages/anki.xml' does not exist

Um okay, this is wrong. https:/git.parabola.nu/abslibre.git/commit/pcr-testing/anki-ccbc?id=d8d414c66f4dd069a31eb1aa34443a7fb59215c7
https://ankiweb.net/shared/decks/
https://git.parabola.nu/abslibre.git/tree/pcr-testing/anki-ccbc?id=d8d414c66f4dd069a31eb1aa34443a7fb59215c7
The anki-ccbc.install scriptlet should not exist. Please don't use xdg-mime install, instead mv the file during package() as upstream should NOT install
/usr/share/anki-ccbc/anki.xml in this location -- it's supposed to be installed to /usr/share/mime/packages/

Pacman hooks will handle its processing at install time.

xdg-mime default is not necessary as it's the user's job to select default applications, but there's only one installed handler for application/x-anki
anyway I'd assume.

#30 - 2020-07-16 02:41 PM - bill-auger
thats i wondered about that - so 'desktop-file-utils' handles
that by magic

i tried to package mnemosyne today, to get an idea of how
strongly it would resist being the absence of webengine - then i
realized that it had 6 python dependencies which would need to
be packaged to support it

#31 - 2020-07-16 05:25 PM - nona

bill-auger wrote:

for the sake of considering more alternatives, is there any reason why 'parley' is not a suitable replacement for 'anki' ? - 'parley' is already in
[libre], patched to use 'qt5-webkit'

| did an initial trial, and it works well for me. It does what it is meant to do. There are features from CCBC that | missed (may be it's the lesson that |
chose?). For instance, with CCBC, you have levels of difficulty when you answer. Most importantly, it would be great to transfer the .apkg into a
suitable Parley format, because there are so many cards already available in CCBC... | also liked and disliked that it has an embedded lesson
downloader. For one, it is nice that you don't need to open your browser and look for the lessons on another website. However, as a Tor user, | would
prefer to actually be able to do precisely that (to prevent DNS leaks and all that; may be it would be nice to have a SOCKS5 proxy option; may be that
is too much to ask from a program like this). | did find something like that, | think. Another thing that | missed is the high level of keyboard shortcuts for
CCBC. What has been mentioned already about the bloat, is something to consider too. My system is like a loaded truck anyways, but | really
understand those users.

#32 - 2020-07-18 06:05 PM - nona
nona wrote:
That line basically replaces =self.setMargin= with =self.setContentsMargins=

which now creates a new error:

(-]
This error happens, evidently due to the type of data provided to the function and it was an overlook on my side...
If we go to the C++ and Python documentation of Qt, we'll find that =setContentsMargins= needs 4 =int= or a =QMargins=. The original code had
=0=. Thus, | just replaced that with 4 =0=. | already pushed the change to my repo
I will next fix the bug for the Browse button.
#33 - 2020-09-13 11:51 AM - theova
As for know, Anki-CCBC is not usable for me.

| think the work of nona goes into the right direction. However, in my opinion it would be better to fork CCBC instead of patching it in the PKGBUILD.
I'm not sure about the amount of work to port a qt4 programm to gt5 - is it doable? If so, | would like to help working on this issue.

#34 - 2020-09-13 12:19 PM - bill-auger

has anyone tried the Mnemosyne program that eli suggested? - it would
probably be less work to maintain

#35 - 2020-09-13 01:07 PM - theova

| tried. However, Mnemosyne depends on qgt-webengine too. | have not looked into it.
bill-auger, you started to build it without webengine?

#36 - 2020-09-13 03:33 PM - eschwartz

| was told that mnemosyne has a python core with multiple frontends, including both a gt webengine frontend and a webpage frontend that you open
in your preferred browser (e.g. Iceweasel).

The webpage frontend would be usable as-is and it's reasonable to think that one could author an additional frontend using a choice of technologies.
https://store.kde.org/browse/cat/216/page/3/ord/latest/
https://doc.qt.io/qt-5/qlayout.html#setContentsMargins
Perhaps fork the webengine frontend into a webkit frontend. Or make one that uses no browser technology at all, and offer that one to upstream.

#37 - 2020-09-13 05:03 PM - nona

theova wrote:
As for know, Anki-CCBC is not usable for me.

| think the work of nona goes into the right direction. However, in my opinion it would be better to fork CCBC instead of patching it in the
PKGBUILD.
I'm not sure about the amount of work to port a qt4 programm to gt5 - is it doable? If so, | would like to help working on this issue.

Yes, indeed. Everything that you said +1. Go forth! Note that my repo is not the same as what exists in Parabola. | would advise you to look into both.

#38 - 2020-09-13 11:50 PM - bill-auger

if memosyne is already configurable, to use xdg-open, that LGTM -
it is the main reason why that mechanism exists - its a shame

that devs do not simply use the system tools, rather than doing

the extra work of integrating a library to duplicate

functionality, which is a reasonable assumption that every GUI
system has

#39 - 2020-09-14 12:40 AM - bill-auger

nona wrote:
theova wrote:
As for know, Anki-CCBC is not usable for me.

it would be better to fork CCBC instead of patching it in the PKGBUILD.
I'm not sure about the amount of work to port a qt4 programm to qt5 - is it doable? If so, | would like to help working on this issue.

Yes, indeed. Everything that you said +1. Go forth!

o/c patching is not ideal; but forking, only for the purpose of
maintaining a patch-set, is pointless - it is exactly the same
amount of work

it is almost always best to work with the upstream to improve
the original - forking should be a last resort, when the
upstream is not interested, or not responsive

in this case, IIRC the main reason why CCBC was forked is not in
order to remove webengine support, but because anki migrated to
QTS5, and was not interested in supporting QT4 - the work nnoa
did was to patch CCBC, so that it use QT5 again; which is very
convoluted

the CCBC fork would have been pointless, if not for QT4
support; and un-doing those changes removes all of the benefit
that the CCBC provides: compatibility with older data-sets IIRC

after doing so, there would likely be nothing remaining of the
CCBC changes - without looking at the code, i assume that the
same could be accomplished by resetting the CCBC git repo, back
to the point where it was forked from anki, then converting it

to support QTS5 - but that is exactly what the anki upstream did

- the result would be an older, un-maintained version of anki,
which supports QT5

if someone were going to maintain a patch-set, which primary
goal is only to remove webengine support, or if a fork was
necessary, then it would surely be more sensible, and less work,
to patch webengine support out of the upstream anki, and forget
about CCBC altogether

presumably, that would be the best way to minimize the patches
that parabola carries, and reduce the over-all maintenance
workload; because the upstream anki would be doing most of the
maintenance
as a side note, it is also worth mentioning, that there is a bug
in the 'pyqt4topyqt5' tool that is used to convert CCBC to QTS5 -
that itself is not a problem because i fixed it, and opened a
merge request on the upstream github in july; but it got no
attention - it appears that nothing interesting has happened to
the repo in over 3 years; so it is likely that 'pyqgt4topyqts’

will cease to function eventually, eg: whenever QT6; and the
current patching trick will no longer be viable

i am not familiar with these programs from a user-perspective;
but from the perspective of a maintainer, memosene would seem to
be the best option; as it may require no maintenance at all

Files
collection.apkg 651 KB 2020-07-16 Anonymous
